﻿Imports Infragistics.Win.UltraWinGrid
Imports Infragistics.Win
Imports Microsoft.Office.Interop

Public Class Form1
    Dim dsGrid As DataSet
    Friend WithEvents xlExporter As Infragistics.Win.UltraWinGrid.ExcelExport.UltraGridExcelExporter
    Dim lbFilter As Boolean = False
    Dim lbGroup As Boolean = True
    Dim lbSummary As Boolean = False
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        dsGrid = New DataSet

        Dim lsFilepath As String = ""
        lsFilepath = Application.StartupPath
        lsFilepath = Replace(lsFilepath, "bin\Debug", "support\reportsummary.xml")
        dsGrid.ReadXml(lsFilepath)
        grdReport.DataSource = dsGrid


        Me.WindowState = FormWindowState.Maximized
    End Sub

    Private Sub UltraButton1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdExcel.Click
        Dim dsdata As New DataSet
        dsdata = grdReport.DataSource
        dsdata.Tables(0).TableName = "Table1"
        xlExporter = New Infragistics.Win.UltraWinGrid.ExcelExport.UltraGridExcelExporter
        xlExporter.Export(grdReport, "e:\grid_withoutchangingtablename.xls")
        Dim oExcel As Excel.Application = Nothing
        Dim oBook As Excel.Workbook = Nothing
        Dim oBooks As Excel.Workbooks = Nothing
        Dim oSheet As Excel.Worksheet = Nothing
        oExcel = New Microsoft.Office.Interop.Excel.Application
        oBooks = oExcel.Workbooks
        oBook = oBooks.Open("e:\grid_withoutchangingtablename.xls", ReadOnly:=False)
        oExcel.Visible = True
    End Sub
    Private Sub UltraButton3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdApplySummary.Click


        If Not lbSummary Then
            grdReport.DisplayLayout.Override.AllowRowSummaries = AllowRowSummaries.True
            lbSummary = True
            cmdApplySummary.Text = "Clear Summary"
            SetSummaryHeaders(True)
        Else
            grdReport.DisplayLayout.Override.AllowRowSummaries = AllowRowSummaries.False
            lbSummary = False
            cmdApplySummary.Text = "Apply Summary"
        End If
    End Sub

    Private Sub SetSummaryHeaders(ByVal pbSetHeader As Boolean)
        'Procedure added by suresh (16/12/11) -R2537
        Try
            Dim lnFirstCell As Integer = -1
            For Each loBand As UltraGridBand In grdReport.DisplayLayout.Bands
                If pbSetHeader Then
                    If loBand.ColHeadersVisible Then
                        lnFirstCell = 0
                        loBand.Summaries.Add("SHA_" & loBand.Index, SummaryType.Formula, loBand.Columns(lnFirstCell), SummaryPosition.UseSummaryPositionColumn)
                        loBand.Summaries(loBand.Summaries.Count - 1).DisplayFormat = "Average : "
                        loBand.Summaries.Add("SHC_" & loBand.Index, SummaryType.Formula, loBand.Columns(lnFirstCell), SummaryPosition.UseSummaryPositionColumn)
                        loBand.Summaries(loBand.Summaries.Count - 1).DisplayFormat = "Count : "
                        loBand.Summaries.Add("SHMX_" & loBand.Index, SummaryType.Formula, loBand.Columns(lnFirstCell), SummaryPosition.UseSummaryPositionColumn)
                        loBand.Summaries(loBand.Summaries.Count - 1).DisplayFormat = "Maximum : "
                        loBand.Summaries.Add("SHMI_" & loBand.Index, SummaryType.Formula, loBand.Columns(lnFirstCell), SummaryPosition.UseSummaryPositionColumn)
                        loBand.Summaries(loBand.Summaries.Count - 1).DisplayFormat = "Minimum : "
                        loBand.Summaries.Add("SHS_" & loBand.Index, SummaryType.Formula, loBand.Columns(lnFirstCell), SummaryPosition.UseSummaryPositionColumn)
                        loBand.Summaries(loBand.Summaries.Count - 1).DisplayFormat = "Sum : "
                    End If
                End If
            Next
        Catch ex As Exception
            'QbShowError(ex)
        End Try
    End Sub
    
End Class
